import java.awt.*;
import javax.swing.*;

public class Questions extends GUI
{
    public static void main(String[] args)
    {
        new Questions();
    }
    
    String slash = System.getProperty("file.separator");
                              //  use / for Mac , \ for Windows
    String folder = System.getProperty("user.dir")+slash;
                    // path+name of project folder
    
    Button next = addButton("Next",20,20,100,50,this); 
    Label question  = addLabel("",150,20,450,50,this);
    Button answer = addButton("Answer",150,80,400,50,this);
    Label score = addLabel("",20,80,100,50,this);    
    
    JLabel pic;               // will show a picture later

    int count = -1; 

    int points = 0;

    Question[] qs = new Question[3];

    public Questions()
    {
        super(600,600);
        loadQuestions();
    }

    public void loadQuestions()
    {
        qs[0] = new Question();
        qs[0].questionText = "Ronald MacDonald is a _______";
        qs[0].answerText = "clown";
        qs[0].fileName = "clown.gif";
        
        qs[1] = new Question();
        qs[1].questionText = "The capital of Germany is _____";
        qs[1].answerText = "Berlin";
        qs[1].fileName = "Germany.png";

        qs[2] = new Question();
        qs[2].questionText = "True/False: Cats like chocolate";
        qs[2].answerText = "False";
        qs[2].fileName = "cats.jpg"; 
    }
    
    public void actions(Object source,String command)
    {
        if(source==next)                   
        {
            nextQuestion();
        } 

        if(source==answer)
        {
            getAnswer();
        } 
    }

    public void nextQuestion()
    {
        count = count + 1;             // counting next question
        if(pic!=null)                  // if pic contains a picture
        {pic.setVisible(false);}       //  erase it
        pic = addJLabel(qs[count].fileName,50,150,500,400,this);
                               // load picture from project's folder
        pic.setVisible(true);  // show the picture
        question.setText(qs[count].questionText);  // show question
        answer.setLabel("Answer");           // write "answer" on button
    }

    public void getAnswer()
    {
        String guess = input("answer?");
        answer.setLabel(guess);          // write guess in Button
        if(guess.equalsIgnoreCase(qs[count].answerText))  // right answer?
        {
            answer.setBackground(new Color(150,255,150)); 
                                        // green means correct
            points = points + 100;      //  win 100               
        }
        else                            // wrong answer
        {
            answer.setBackground(new Color(255,150,150));
                                        // red means wrong
            points = points - 40;       //  lose 40
        }      
        score.setText(points + "");     // show points in label
    }
}

class Question
{
    String questionText = "";
    String answerText = "";
    String fileName = "";
}

/****************************************************
This program demonstrates the use of an Object array
to store Question objects, where each Question object
contains questionText, answerText and fileName .

(1) Run the program and check that it works.
    Try both correct and incorrect answers.
    The correct answers are shown in the answers[] array.
    
(2) Add a CONSTRUCTOR that works like this:

    qs[3] = new Question("Who is The King?","Elvis","elvis.png");
    
    This makes the code for adding question considerably shorter.
    
    The Constructor belongs inside the Question class,
    and it looks like this:
    
      public Question(String q, String a, String f)
      {
          questionText = q;
          answerText = a;
          fileName = f;
      }

(3) Add 2 more questions (using the new Constructor).

(4) There are several ERRORS in the program.
    That does not means it is broken, but rather
    it does not behave as the user would expect. 
    There may be different errors in this version
    than there were in the Parallel Arrays version.
    Find all the errors and fix them.
    
(5) Add a new ATTRIBUTE (field/variable/property)
    called "correct".  This is a boolean value,
    which keeps track of whether the question was 
    answered correctly or not. 
    
(6) Change the program so that it only allows one
    try at each question.  That means that after
    the user has answered incorrectly, the [answer]
    button is disabled.  Then it must be re-enabled
    when the user clicks [next].
    
(7) At the end, after the player has answered all questions,
    the program should scan through the array looking
    for a question that was answered incorrectly.
    Now it should present this question one more time.
    This should continue until there are not incorrect questions
    remaining in the array.
    
*****************************************************/
